library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity decoder2x4 is
port ( i: in integer range 0 to 4;
       en: in std_logic;
       q: out std_logic_vector( 0 to 3)
       );
 end decoder2x4;
 
 architecture dataflow of decoder2x4 is
 signal t: std_logic_vector(0 to 3);
 begin
    
    with i select
     t <=  "1000" when 0,
           "0100" when 1,
           "0010" when 2,
           "0001" when 3,
           "0000" when others;
      
     q <= t after 2 ns when en= '1' else
          "0000";              
 end dataflow;
