library ieee;

use ieee.std_logic_1164.all;
entity decoder2x4 is
port ( i: in std_logic_vector( 0 to 1); --integer range 0 to 4;
       en: in std_logic;
       q: out std_logic_vector( 0 to 3)
       );
 end decoder2x4;
 
 architecture dataflow of decoder2x4 is
 signal t: std_logic_vector(0 to 3);
 begin
    
    with i select
     t <=  "1000" after 1 ns when "00",
           "0100" when "01",
           "0010" when "10",
           "0001" when "11",
           "0000" when others;
      
     q <= t after 2 ns when en= '1' else
          "0000";              
 end dataflow;
